<template>
  <ModalsBase
    :id="id"
    :footer="false"
    :header="false"
    :centered="false"
    :visible="visible"
    size="xl"
    bodyclass="p-0 overflow-auto"
    @hidden="modalHidden()"
    @shown="$emit('shown')"
  >
    <template #body>
      <div style="max-height: 94vh">
        <div class="pb-0 pt-3 px-3">
          <div class="mb-3">
            <div class="subheader mb-2">Search</div>
            <b-form-input
              v-model="valueToSearch"
              v-debounce:500ms="searchInWorkspace"
              data-cy="search-workspace-input-modal"
              :placeholder="
                !dataReturned ? 'Wait, fetching data...' : 'Search...'
              "
              :disabled="!dataReturned"
              class="mb-1"
              debounce-events="input"
              autofocus
            >
            </b-form-input>
          </div>
        </div>
        <div v-if="dirty">
          <div
            v-if="
              filteredProjects.length ||
              filteredScenarios.length ||
              filteredDatasets.length
            "
          >
            <div v-if="filteredProjects.length" class="p-3">
              <h2>Projects</h2>
              <hr class="mt-0" />
              <CarouselCards
                :cards="filteredProjects"
                card-component="ProjectCard"
                key-card-component="project"
              ></CarouselCards>
            </div>
            <div v-if="filteredScenarios.length" class="p-3">
              <h2>Scenarios</h2>
              <hr class="mt-0" />
              <CarouselCards
                :cards="filteredScenarios"
                card-component="ScenarioCard"
                key-card-component="scenario"
              ></CarouselCards>
            </div>
            <div v-if="filteredDatasets.length" class="p-3">
              <h2>Datasets</h2>
              <hr class="mt-0" />
              <CarouselCards
                :cards="filteredDatasets"
                card-component="DatasetCard"
                key-card-component="dataset"
              ></CarouselCards>
            </div>
          </div>
          <EmptyData
            v-else
            title="Data not found"
            description="Data not found for your search"
            image="/illustrations/empty-project-board.svg"
          >
          </EmptyData>
        </div>
      </div>
    </template>
  </ModalsBase>
</template>
<script>
import { mapGetters } from 'vuex';
import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  props: {
    id: {
      type: String,
      default: '',
    },
    visible: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      dataReturned: false,
      valueToSearch: '',
      dirty: false,
      filteredProjects: [],
      filteredScenarios: [],
      filteredDatasets: [],
      filters: {
        project: {
          filterBy: [
            { filterBy: 'title' },
            { filterBy: 'state.title' },
            { filterBy: 'author.username' },
            { filterBy: 'short_description' },
          ],
          orderBy: 'creation_datetime',
          direction: 'Descending',
        },
        scenario: {
          filterBy: [
            { filterBy: 'title' },
            { filterBy: 'user.username' },
            { filterBy: 'description' },
          ],
          orderBy: 'date.creation',
          direction: 'Descending',
        },
        dataset: {
          filterBy: [{ filterBy: 'title' }, { filterBy: 'short_description' }],
          orderBy: "versions.'1.0.0'.date",
          direction: 'Descending',
        },
      },
    };
  },
  computed: {
    ...mapGetters({
      projects: 'projects/allProjects',
      datasets: 'datasets/allDatasets',
      scenarios: 'scenarios/allScenarios',
    }),
  },
  watch: {
    async visible() {
      if (!this.dataReturned) {
        await this.$nuxt.context.store.dispatch('projects/fetchProjects');
        await this.$nuxt.context.store.dispatch('scenarios/fetchScenarios');
        await this.$nuxt.context.store.dispatch('datasets/fetchDatasets');
        this.dataReturned = true;
      }
    },
  },
  methods: {
    searchInWorkspace() {
      this.dirty = true;
      if (this.valueToSearch === '') {
        this.filteredProjects = this.projects;
        this.filteredScenarios = this.scenarios;
        this.filteredDatasets = this.datasets;
      } else {
        this.filteredProjects = this.searchFunction(
          this.valueToSearch,
          this.projects,
          this.filters.project
        );
        this.filteredScenarios = this.searchFunction(
          this.valueToSearch,
          this.scenarios,
          this.filters.scenario
        );
        this.filteredDatasets = this.searchFunction(
          this.valueToSearch,
          this.datasets,
          this.filters.dataset
        );
      }
      this.filteredProjects = this.applyFilter(
        this.filters.project,
        this.filteredProjects
      );
      this.filteredScenarios = this.applyFilter(
        this.filters.scenario,
        this.filteredScenarios
      );
      this.filteredDatasets = this.applyFilter(
        this.filters.dataset,
        this.filteredDatasets
      );
    },
    modalHidden() {
      this.dirty = false;
      this.valueToSearch = '';
      this.$emit('hidden');
    },
  },
};
</script>
